
import java.util.*;

class Customer {
    protected String _name;
    private Vector _rentals = new Vector();
    
    protected Customer() {
    }

    public Customer(String name) {
        _name = name;
    }

    public void addRental(Rental arg) {
        _rentals.add(arg);
    }

    public String getName() {
        return _name;
    }

    public String getMovieTitle(Rental each) {
        return each.getMovie().getTitle();
    }

    public String statement() {
        double totalAmount = 0;
        Iterator rentals = _rentals.iterator();
        String result = "Rental Record for " + getName() + "\n";
        
        while (rentals.hasNext()) {
            double thisAmount = 0;
            Rental each = (Rental)rentals.next();

            thisAmount = amountFor(each);
            result += "\t" + getMovieTitle(each) + "\t" +
                String.valueOf(thisAmount) + "\n";
            totalAmount += thisAmount;
        }

        result += "Amount owed is " + String.valueOf(totalAmount);
        return result;
    }

    private double amountFor(Rental each) {
        double result = 0;
        switch (each.getMovie().getPriceCode()) {
            case Movie.REGULAR:
                result += 2;
                if (each.getDaysRented() > 2)
                    result += (each.getDaysRented() - 2) * 1.5;
                break;
            case Movie.NEW_RELEASE:
                result += each.getDaysRented() * 3;
                break;
            case Movie.CHILDRENS:
                result += 1.5;
                if (each.getDaysRented() > 3)
                    result += (each.getDaysRented() - 3 ) * 1.5;
                break;
        }
        return result;
    }
}
