/*
 *     SimpleTest.java  Nov 10, 2001
 *
 *     Katsuhisa Maruyama (maru@fse.cs.ritsumei.ac.jp)
 */

import jp.ac.ritsumei.cs.fse.jrt.parser.summary.*;
import java.io.*;

public class SimpleTest {

    public static void main(String args[]) {
        if (args.length == 1) {
            String JDKFilePath;
            if (System.getProperty("os.name").startsWith("Windows")) {
                JDKFilePath = "c:\\jdk1.3.1\\src.jar";
            } else {
                JDKFilePath = "/usr/local/j2sdk1_3_1/src.jar";
            }
            Summary.getInstance().setJDKFile(JDKFilePath);

            String fileName = args[0];
            if (fileName.lastIndexOf('.') != -1) {
                String dirName = fileName.substring(0, fileName.lastIndexOf(File.separator));

                Summary.getInstance().parse(dirName);
                Summary.getInstance().print();
            }
        } else {
            System.err.println("Usage: java jp.ac.ritsumei.cs.fse.jrt.parser.SimpleTest inputfile");
            return;
        }
    }
}
