/*
 *     ExtractSuperclassTest.java  Dec 19, 2001
 *
 *     Katsuhisa Maruyama (maru@fse.cs.ritsumei.ac.jp)
 */

import jp.ac.ritsumei.cs.fse.jrt.refactor.classes.*;
import jp.ac.ritsumei.cs.fse.jrt.refactor.util.test.RefactoringTest;
import jp.ac.ritsumei.cs.fse.jrt.refactor.Refactoring;
import jp.ac.ritsumei.cs.fse.jrt.refactor.util.*;
import jp.ac.ritsumei.cs.fse.jrt.model.*;
import jp.ac.ritsumei.cs.fse.jrt.parser.summary.Summary;
import javax.swing.JFrame;

public class ExtractSuperclassTest extends RefactoringTest {

    public static void main(String args[]) {
        if (args.length >= 3) {
            String dir = ".";
            Summary.getInstance().parse(dir);

            JavaFile jfile = doParse(args[0]);
            JavaComponent jc = getJC(jfile, args[1], args[2]);

            JFrame f = new JFrame();
            f.setVisible(true);

            if (jc.isJavaClass()) {
                JavaClass jclass = (JavaClass)jc;

                Refactoring refactoring;
                if (args.length == 3) {
                    refactoring = new ExtractSuperclass(f, jclass, dir, null);
                } else {
                    refactoring = new ExtractSuperclass(f, jclass, dir, args[3]);
                }
                refactoring.execute(); 
            }
            System.exit(0);
        } else {
            System.err.println("Usage: ExtractSuperclassTest inputfile line column [new_name]");
            return;
        }
    }
}
