/*
 *     RefactoringTest.java  Dec 19, 2001
 *
 *     Katsuhisa Maruyama (maru@fse.cs.ritsumei.ac.jp)
 */

package jp.ac.ritsumei.cs.fse.jrt.refactor.util.test;
import jp.ac.ritsumei.cs.fse.jrt.refactor.util.*;
import jp.ac.ritsumei.cs.fse.jrt.model.*;
import jp.ac.ritsumei.cs.fse.jrt.parser.*;
import jp.ac.ritsumei.cs.fse.jrt.parser.summary.*;
import java.io.*;

public class RefactoringTest {
    protected JavaFile getJavaFile(JavaFile jfile, String name) {
        SummaryJavaFile sfile = jfile.getSummaryJavaFile();
        String qname = sfile.getQualifiedName(name);

        return JavaModelFactory.getInstance().getEachJavaFile(qname + ".java");
    }

    protected static JavaFile doParse(String fileName) {
        String dirName = ".";
        if (fileName.indexOf(File.separator) != -1) {
            dirName = fileName.substring(0, fileName.lastIndexOf(File.separator));
        }

        String JDKFilePath;
        if (System.getProperty("os.name").startsWith("Windows")) {
            JDKFilePath = "c:\\jdk1.3.1\\src.jar";
        } else {
            JDKFilePath = "/usr/local/j2sdk1_3_1/src.jar";
        }
        JavaModelFactory.getInstance().setJDKFile(JDKFilePath);

        JavaFile jfile = JavaModelFactory.getInstance().getEachJavaFile(fileName);
        jfile.setText(readFile(fileName));

        return jfile;
    }

    protected static JavaComponent getJC(JavaFile jfile, String l, String c) {
        if (jfile != null) {
            int line = Integer.parseInt(l);
            int column = Integer.parseInt(c);
            PositionVisitor visitor = new PositionVisitor();
            
            JavaComponent jc = visitor.getTokenAt(jfile, line, column);
            return jc;
        }
        return null;
    }

    private static String readFile(String name) {
        StringBuffer content;
        try {
            File file = new File(name);
            BufferedReader reader = new BufferedReader(new FileReader(file));
            content = new StringBuffer();
            while (reader.ready()) {
                String oneLineString = reader.readLine();
                if (oneLineString == null) {
                    break;
                }
                content.append(oneLineString + "\n");
            }
            reader.close();

            return new String(content);

        } catch (FileNotFoundException e) {
        } catch (IOException e) {
        }
        return null;
    }
}
