/*
 *     SummaryParseTest.java  Nov 14, 2001
 *
 *     Katsuhisa Maruyama (maru@fse.cs.ritsumei.ac.jp)
 */

import jp.ac.ritsumei.cs.fse.jrt.parser.summary.*;
import jp.ac.ritsumei.cs.fse.jrt.util.WarningEvent;
import jp.ac.ritsumei.cs.fse.jrt.util.WarningEventListener;
import java.util.*;
import java.io.*;
import junit.framework.*;

public class SummaryParseTest extends TestCase implements WarningEventListener {
    private static boolean parseException;

    public SummaryParseTest(String name) {
        super(name);
    }

    public static void main(String args[]) {
        junit.textui.TestRunner.run(suite());
    }

    protected void setUp() {
        String JDKFilePath;
        if (System.getProperty("os.name").startsWith("Windows")) {
            JDKFilePath = "c:\\jdk1.3.1\\src.jar";
        } else {
            JDKFilePath = "/usr/local/j2sdk1_3_1/src.jar";
        }
        Summary.getInstance().setJDKFile(JDKFilePath);
        Summary.getInstance().addWarningEventListener(this);
    }

    protected void tearDown() {
    }

    public static Test suite() {
        TestSuite suite = new TestSuite();

        List testcases = new ArrayList();
        testcases.add(new String("./testcases/chart"));
        testcases.add(new String("./testcases/fowler"));
        testcases.add(new String("./testcases/tetris"));

        String jdkDir = "/home/maru/Work/JRT/src/jp/ac/ritsumei/cs/fse/java-src/";
        //*NG testcases.add(new String(jdkDir + "com"));
        // testcases.add(new String(jdkDir + "java/applet"));
        // testcases.add(new String(jdkDir + "java/awt"));
        // testcases.add(new String(jdkDir + "java/beans"));
        //*NG testcases.add(new String(jdkDir + "java/io"));
        //*NG testcases.add(new String(jdkDir + "java/lang"));
        // testcases.add(new String(jdkDir + "java/math"));
        // testcases.add(new String(jdkDir + "java/net"));
        // testcases.add(new String(jdkDir + "java/rmi"));
        // testcases.add(new String(jdkDir + "java/security"));
        // testcases.add(new String(jdkDir + "java/sql"));
        //*NG testcases.add(new String(jdkDir + "java/text"));
        // testcases.add(new String(jdkDir + "java/util"));
        // testcases.add(new String(jdkDir + "javax/accessibility"));
        //*NG testcases.add(new String(jdkDir + "javax/naming"));
        //*NG testcases.add(new String(jdkDir + "javax/swing"));
        // testcases.add(new String(jdkDir + "org"));
        // testcases.add(new String(jdkDir + "sun"));
        // testcases.add(new String(jdkDir + "sunw"));

        Iterator it = testcases.iterator();
        while (it.hasNext()) {
            final String dir = (String)it.next();
            suite.addTest(new SummaryParseTest("Parse Test" + dir) {
                protected void runTest() {
                    testParseException(dir);
                }
            });
        }
        return suite;
    }

    public void testParseException(String dir) {
        parseException = false;
        System.out.println("DIRNAME = " + dir);
        Summary.getInstance().parse(dir);
        assertTrue(!parseException);
    }

    /* WarningEventListener */
    public void printMessage(WarningEvent evt) {
        System.out.println(evt.getMessage());
        parseException = true;
    }
}
